plugins['queuecounter'] = (function() {

    var speechtexto        = "";
    var speechstring       = pluginconfig['queuecounter']['announcement_text'][''];
    var speechstringfailed = pluginconfig['queuecounter']['failed_announcement_text'][''];
    var enable_announce    = parseInt(pluginconfig['queuecounter']['enable_spoken_announcement']['']);
    var enable_f_announce  = parseInt(pluginconfig['queuecounter']['enable_failed_spoken_announcement']['']);
    var langu              = pluginconfig['queuecounter']['language'][''];

    return { 

        loadLang: function(values) {
            var hash = hex_md5(secret+lastkey);
            queuedcommand = "<msg data=\"" + myposition + "|pluginlang|" + language + "~queuecounter" + "|" + hash + "\" />";
            sendcommand();
        },
        setLang: function() {
            if($('#queuecountTitle').length>0) {
                debug('set lang queuecounter');
                $('#queuecountTitle').html(lang.queuecallcounter);
            }
        },
        init: function() {
            // initialization function
        },
        callback_zbuttons: function() {
            if($('#box_queuecounterbox').length<=0) {
                var klon = $( '#box_asternicTagbox' );
                var newklon = klon.clone().attr( { id: 'box_queuecounterbox' }).css({display: 'block'}).insertBefore( klon );
                newklon.find('*').each(function() {
                   if(typeof $(this).attr('id') == 'undefined') {
                   } else {
                       if($(this).attr('id')=='tagcall') { $(this).attr('id','queuecountTitle').html(lang.queuecallcounter); }
                       if($(this).attr('id')=='toggle-asternicTag') { $(this).attr('id','toggle-queuecounter'); }
                       if($(this).attr('id')=='asternicTag') { $(this).attr('id','queuecounter').css('text-align','center'); }
                   }
                });
            }

            makeSortable('right');

            if(typeof(mypreferences.rightColumnOrder)=='string') {
                ordenarDiv('right_column',mypreferences.rightColumnOrder);
            }

        },
        callback_waitingcalls: function(nro,texto,slot) {
            debug('state en queuecounter');
            waitingcalls=0;
            waitingcalls = $('#queuelist').find('.qentrylabel').length;
            $('#queuecounter').html('<h1>'+waitingcalls+'</h1>');
            var queue_label = botonitos[nro]['LABEL'];
            var calls_waiting = texto;
            speechtexto = speechstring;
            debug(speechtexto);
            var reemplazo1 = speechtexto.replace("#{COUNT}",calls_waiting);
            var reemplazo2 = reemplazo1.replace("#{QUEUE}",queue_label);
            speechtexto = reemplazo2;
            debug(speechtexto);
        },
        callback_soundjoin: function(nro,texto,slot) {
            debug(speechtexto);
            if ('speechSynthesis' in window) {
                if(enable_announce==1) {
                    var msg = new SpeechSynthesisUtterance(speechtexto);
                    msg.lang = langu;
                    if(mypreferences.soundQueue == "") {
                    } else {
                        window.speechSynthesis.speak(msg);
                    }
                }
            }
        },
        callback_noanswersound: function(nro,texto,slot) {
             var textodecode = Base64.decode(texto);
             var partes      = textodecode.split('^');
             var agent       = partes[0];
             var queue       = partes[1];
             var queuename   = queue;

             if ('speechSynthesis' in window) {
                 if(enable_f_announce==1) {

                     for (var s = 0; s < botonitos.length; s++) {
                        for (var i in botonitos[s]) {
                            if (botonitos[s].hasOwnProperty(i)) {
                                 if (i == "TYPE") {
                                     if(botonitos[s]['TYPE']=='queue') {
                                         if(botonitos[s]['EXTENSION']==queue) {
                                             queuename = botonitos[s]['LABEL'];
                                             break;
                                         }
                                     }
                                 }
                             }
                         }
                     }
   
                     var reemplazo1 = speechstringfailed.replace("#{AGENT}",agent);
                     var reemplazo2 = reemplazo1.replace("#{QUEUE}",queuename);
    
                     debug('About to say no answer phrase: ' +reemplazo2);
    
                     var msg = new SpeechSynthesisUtterance(reemplazo2);
                     if(mypreferences.soundQueue == "") {
                     } else {
                         window.speechSynthesis.speak(msg);
                     }
                 }
             }
        },
        callback_clearentries: function(nro,texto,slot) {
            debug('state en queuecounter');
            waitingcalls=0;
            waitingcalls = $('#queuelist').find('.qentrylabel').length;
            $('#queuecounter').html('<h1>'+waitingcalls+'</h1>');
        }
    }
}());
